--------------------------------------------------------------------------------
--
-- Copyright (C) 2014
-- ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
-- P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
--------------------------------------------------------------------------------

LIBRARY IEEE, common_lib, dp_lib;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;
USE common_lib.common_pkg.ALL;
USE dp_lib.dp_stream_pkg.ALL;
USE common_lib.tb_common_pkg.ALL;

ENTITY tb_corr_folder IS
  GENERIC (
    g_nof_inputs  : NATURAL := 4;
    g_folder_factor : NATURAL := 2
  );
END tb_corr_folder;

ARCHITECTURE tb OF tb_corr_folder IS

  CONSTANT c_clk_period            : TIME := 10 ns;
  CONSTANT c_data_w                : NATURAL := 32;

  SIGNAL tb_end                    : STD_LOGIC := '0';
  SIGNAL clk                       : STD_LOGIC := '1';
  SIGNAL rst                       : STD_LOGIC;

  SIGNAL folder_snk_in_2arr_2  : t_dp_sosi_arr(g_nof_inputs-1 DOWNTO 0);
  SIGNAL folder_src_out_2arr_2 : t_dp_sosi_2arr_2(g_nof_inputs/g_folder_factor-1 DOWNTO 0);  

BEGIN

  clk <= NOT clk OR tb_end AFTER c_clk_period/2;
  rst <= '1', '0' AFTER c_clk_period*7;

END tb;
